<?php
date_default_timezone_set('PRC');
require_once __DIR__ . '/vendor/autoload.php';
use Workerman\Worker;
use Workerman\Timer;
use Workerman\Connection\AsyncTcpConnection;

//配置 (说明 https://www.nowapi.com/docs/nms-index.html)
$setParmA['host']        = 'nms-aaa.nowapi.com';//服务器
$setParmA['port']        = '443';//端口
$setParmA['ssl']         = '1';//是否ssl加密 0:否 1:是
$setParmA['instanceId']  = 'ins-10003';//实例名
$setParmA['accessKey']   = '8512547106565e12544125007942565e';//客户端KEY
$setParmA['secretKey']   = '';//安全密钥
$setParmA['userId']      = 'php-'.rand(10000,99999);//客户端唯一ID
$setParmA['channels']    = 'php-demoWorkerman';//订阅通道(多个用逗号隔开)
$setParmA['onOpen']      = function(){};//连接成功触发
$setParmA['onMessage']   = function($msgData){};//收到消息触发
$setParmA['onClose']     = function(){};//与服务器断开
$setParmA['onFailed']    = function($msgFailed){};//异常消息触发
$setParmA['onTaskTimer'] = function($worker,$con){};//定时器

//接收消息处理
$setParmA['onMessage']   = function($msgData){
    $msgId      = $msgData['i'];
    $msgTime    = $msgData['t'];
    $msgChannel = $msgData['n'];
    $msgContent = $msgData['c'];

    echo "       msgId : ".$msgId."\r\n";
    echo "     msgTime : ".date('Y-m-d H:i:s',substr($msgTime,0,-3))." ".substr($msgTime,0,-3)."\r\n";
    echo "  msgChannel : ".$msgChannel."\r\n";
    echo "  msgContent : ".$msgContent."\r\n";
    echo "      decode : ".urldecode($msgContent)."\r\n";
    echo "----\r\n";
};

//推送消息逻辑 本例定时器每10秒执行一次
$setParmA['onTaskTimer'] = function($worker,$con){
    $phpOS = strtolower(PHP_OS);
    //数据采集提取
    $extData = '';
    if($phpOS=='linux'){
        $extData = shell_exec('ping 119.29.29.29 -c 1');
    }elseif($phpOS=='winnt'){
        $extData = shell_exec('ping 119.29.29.29 -n 1');
    }
    //提取
    $rspDelayMs = 0;
    $extA       = array();
    preg_match('/time=([\d.\ ]+)ms/i',$extData,$extA);
    //print_r($extData);
    //print_r($extA);
    if(!empty($extA[1])){
        $rspDelayMs = trim($extA[1]);
    }

    //编码后传递
    $rspDataA['rspArea']    = 'TXDNS';
    $rspDataA['rspDelayMs'] = $rspDelayMs;
    $rspData = urlencode(json_encode($rspDataA));
    //
    $pushChannel = 'php-demoWorkerman';//向该通道推送
    $con->send('["publish",{"channels":"'.$pushChannel.'","content":"'.$rspData.'"}]');
};

//异常时触发
$setParmA['onFailed'] = function($msgFailed){
    echo date('Y-m-d H:i:s')." ERR: ".$msgFailed."\r\n";
};

//与服务器断开时触发
$setParmA['onClose'] = function(){
    echo date('Y-m-d H:i:s')." Connection closed and try to reconnect\r\n";
};






//workermain进程
$worker = new Worker();
$worker->onWorkerStart = function($worker) use($setParmA){
    //配置
    $host       = $setParmA['host'];
    $port       = $setParmA['port'];
    $ssl        = $setParmA['ssl'];//是否ssl加密 0:否 1:是
    $instanceId = $setParmA['instanceId'];
    $accessKey  = $setParmA['accessKey'];
    $secretKey  = $setParmA['secretKey'];
    $userId     = $setParmA['userId'];//指定客户端唯一ID

    //运行参数
    $worker->heartbeatPingInterval = 5000;//心跳包间隔
    $worker->heartbeatTimeId       = 0;//心跳定时器ID
    $worker->taskTimeId            = 0;//任务定时器ID

    //连接
    $con = new AsyncTcpConnection('ws://'.$host.':'.$port.'/?instanceId='.$instanceId);

    //设置以ssl加密方式访问，使之成为wss
    if($ssl==1){
        $con->transport = 'ssl';
    }

    //连接
    $con->onWebSocketConnect = function(AsyncTcpConnection $con) use($accessKey,$secretKey,$userId) {
        $safeCode = '';
        if(!empty($secretKey)){
            $safeCode = openssl_encrypt(round(microtime(true)*1000).'___','AES-128-ECB',$secretKey,2,'');
        }
        $con->send('["authorize",{"accessKey":"'.$accessKey.'","userId":"'.$userId.'","safeCode":"'.$safeCode.'"}]');
    };
    //收到消息
    $con->onMessage = function(AsyncTcpConnection $con,$onData) use($worker,$setParmA){
        $channels  = $setParmA['channels'];
        $onMessage = $setParmA['onMessage'];
        try{
            //心跳
            if(trim($onData)==='2'){
                throw new Exception('INF_HEARTBEAT',1);
            }
            //数据
            $onDataA = json_decode($onData,true);
            if(!is_array($onDataA)){
                throw new Exception('ERR_DATA_FORMAT',-1);
            }
            $rcvType  = $onDataA[0];
            $rcvData  = $onDataA[1];

            //通用响应
            if(in_array($rcvType,array('subscribe','unsubscribe','publish'))){
                if($rcvData['resultCode']!='200'){
                    throw new Exception($onData,-1);
                }else{
                    throw new Exception($onData,1);
                }
            }elseif($rcvType=='message'){
                //消息确认
                if(!empty($rcvData['i'])){
                    $con->send('["messageack",{"i":"'.$rcvData['i'].'"}]');
                }else{
                    throw new Exception($onData,-1);
                }
            }

            //逻辑响应
            if($rcvType=='authorize'){
                if($rcvData['resultCode']=='200' && is_numeric($rcvData['resultContent']['pingInterval'])){
                    //启动定时器推送心跳包
                    $worker->heartbeatPingInterval = $rcvData['resultContent']['pingInterval'];
                    $worker->heartbeatTimeId = Timer::add($worker->heartbeatPingInterval/1000,function() use ($worker,$con){
                        $con->send('1');
                    });
                    //清空订阅
                    $con->send('["unsubscribe",{"channels":[]}]');
                    //新订阅
                    $con->send('["subscribe",{"channels":"'.$channels.'"}]');
                }
                throw new Exception('INF_AUTHORIZE ['.$worker->heartbeatPingInterval.'/'.$worker->heartbeatTimeId.']',1);
            }
            //收到消息执行回调函数
            elseif($rcvType=='message'){
                if(is_object($onMessage)){
                    $onMessage($rcvData);
                }
            }
        }catch(Exception $ex){
            $errCode = $ex->getCode();
            if($errCode!==1){
                if(is_object($setParmA['onFailed'])){
                    $setParmA['onFailed']($ex->getMessage());
                }
            }
        }
    };

    //异常
    $con->onError = function(AsyncTcpConnection $con,$code,$msg) use($setParmA){
        if(is_object($setParmA['onFailed'])){
            $setParmA['onFailed']($msg);
        }
    };

    //断开
    $con->onClose = function($con) use($worker,$setParmA){
        // 清理timer
        Timer::del($worker->heartbeatTimeId);
        Timer::del($worker->taskTimeId);
        //
        if(is_object($setParmA['onClose'])){
            return $setParmA['onClose']();
        }
        // 如果连接断开，1秒后重连
        $con->reConnect(5);
    };

    //自定义任务
    $worker->taskTimeId = Timer::add(3,function() use ($worker,$con,$setParmA){
        if(is_object($setParmA['onTaskTimer'])){
            return $setParmA['onTaskTimer']($worker,$con);
        }
    });

    //
    $con->connect();
};

Worker::runAll();

